// leftpane.cpp
// Copyright (C) 2007-2009 Andrew Munkres
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

#include <klocale.h>
#include <kdebug.h>
#include <QHeaderView>
#include <QContextMenuEvent>
#include "leftpane.h"

#include "koeurlconfig.h" // Autogenerated by kconfig_compiler

#include "leftpane.moc" // This must be here for moc to be run.

LeftPane::LeftPane(QSplitter *parent): MyTreeWidget(parent),
  m_shown(Settings::leftPaneShown())
{
  setColumnCount(1);
  setHeaderLabel(i18n("Repository"));
  header()->setResizeMode(QHeaderView::Interactive);
  header()->setVisible(true);
  
  // header()->restoreState(QByteArray::fromBase64(
  //                          Settings::leftPaneHeaderState().toLocal8Bit()));
  QString state(Settings::leftPaneHeaderState());
  // kDebug() << i18n("Read left pane state from KConfig: %1").arg(state);
  if (!state.isEmpty())
    header()->restoreState(QByteArray::fromBase64(state.toLocal8Bit()));
  // TODO: find out what string to put as the default in koeurl.kcfg
  
  connect(this, SIGNAL(contextMenu(QTreeWidgetItem *, const QPoint &)),
          parent->parent(), SLOT(showRepoMenu(QTreeWidgetItem *,
                                              const QPoint &)));
  connect(this, SIGNAL(selectionChanged(QTreeWidgetItem *)),
          parent->parent(), SLOT(selectRepo(QTreeWidgetItem *)));
}

LeftPane::~LeftPane()
{
  // saveLayout(Settings::self()->config(), "Left Pane List View");
  // QString state(header()->saveState().toBase64());
  // kDebug() << i18n("About to write left pane state to KConfig: %1").arg(state);
  // Settings::setLeftPaneHeaderState(state);
  Settings::setLeftPaneHeaderState(header()->saveState().toBase64());
  Settings::self()->writeConfig();
}

void LeftPane::contextMenuEvent(QContextMenuEvent *event)
{
  QList<QTreeWidgetItem *> si(selectedItems());
  QTreeWidgetItem *item(0);
  if (0 != si.size())
    item = si.first();
  emit contextMenu(item, event->globalPos());
}

void LeftPane::toggleShown(bool)
{
  if (m_shown)
  {
    m_shown = false;
    hide();
  }
  else
  {
    m_shown = true;
    show();
  }
  Settings::setLeftPaneShown(m_shown);
  Settings::self()->writeConfig();
}
